Imports System.Net
Imports System.Text
Imports System.IO
Imports System
Imports Microsoft.Win32
Public Class GetImage
    Public Shared Function GetImage() As Image
        Dim objImage As MemoryStream
        Dim objwebClient As WebClient
        Dim Pic As Bitmap = Nothing
        Dim sURL As String = Trim(GetImageURL())
        Try
            'Check if url is wellformed
            If Not sURL.StartsWith("http://") Then sURL = "http://" & sURL
            objwebClient = New WebClient()

            'Load the image
            objImage = New MemoryStream(objwebClient.DownloadData(sURL))
            Pic = Image.FromStream(objImage)
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error")
        End Try

        'Return the image
        Return Pic
    End Function
    Private Shared Function GetImageURL() As String

        'Get path from registry
        Dim Settings As RegistryKey
        Settings = Registry.LocalMachine.OpenSubKey("Software\CopperScreen", False)
        Dim server As String = Settings.GetValue("picUri", "")

        'Load url
        Dim UriServer As String = server & GetQueryString()
        Dim picUri As String = "http://coppermine-gallery.net/images/cpg.gif"
        Try
            Dim Req As WebRequest = WebRequest.Create(UriServer)
            Dim Resp As WebResponse = Req.GetResponse()
            Dim sr As New StreamReader(Resp.GetResponseStream(), Encoding.ASCII)

            'Read a line and save to temp
            Dim temp As String = sr.ReadLine

            'check if empty
            If Not temp = "" Then picUri = temp

            'close streamreader
            sr.Close()

        Catch ex As WebException
            MessageBox.Show(ex.Message & vbCrLf & "This is probably caused by incorrect data in the 'random.php' file", "Error")
        End Try

        'Return the image uri
        Return picUri
    End Function
    Private Shared Function GetQueryString() As String
        Dim QueryString As String = ""
        Try
            'Look for the querystring
            Dim Settings As RegistryKey
            Settings = Registry.LocalMachine.OpenSubKey("Software\CopperScreen", True)
            If Settings.GetValue("meta", "?meta=random") = "" Then
                QueryString = "?meta=random"
            Else
                QueryString = Settings.GetValue("meta", "?meta=random")
            End If


            QueryString += Settings.GetValue("album", "")

        Catch ex As Exception
            MessageBox.Show("Error while saving to registry: " & ex.Message)
        End Try
        Return (QueryString)

    End Function
    Public Shared Sub CheckRegistry()
        Try
            Dim Settings As RegistryKey
            Settings = Registry.LocalMachine.OpenSubKey("Software\CopperScreen", True)
            'If the key doesn't exist, create it
            If Settings Is Nothing Then
                Settings = Registry.LocalMachine.CreateSubKey("Software\CopperScreen")
            End If
        Catch ex As Exception
            MessageBox.Show("Error while saving to registry: " & ex.Message)
        End Try
    End Sub
End Class
