Imports CopperScreen.GetImage
Imports System.Drawing.Imaging
Imports System.Drawing.Image
Imports System.Drawing
Imports Microsoft.Win32
Public Class frmMain
    Inherits System.Windows.Forms.Form
    Public sDisplay As String()
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Dim gTolerance As Integer
    Friend WithEvents PicBox As System.Windows.Forms.PictureBox
    Dim Time As Integer = 0
    Dim Overlay As New frmOverlay
    Dim PreloadPic As Bitmap = Nothing
    'Global settings
    Dim Transition As String
    Dim TransTime As Integer = 10


#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Timer1 As System.Windows.Forms.Timer
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.Timer1 = New System.Windows.Forms.Timer(Me.components)
        Me.Label1 = New System.Windows.Forms.Label
        Me.PicBox = New System.Windows.Forms.PictureBox
        CType(Me.PicBox, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'Timer1
        '
        Me.Timer1.Enabled = True
        Me.Timer1.Interval = 1000
        '
        'Label1
        '
        Me.Label1.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.Label1.AutoSize = True
        Me.Label1.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label1.ForeColor = System.Drawing.Color.FromArgb(CType(CType(64, Byte), Integer), CType(CType(64, Byte), Integer), CType(CType(64, Byte), Integer))
        Me.Label1.Location = New System.Drawing.Point(222, 254)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(65, 13)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "By SaWey"
        Me.Label1.TextAlign = System.Drawing.ContentAlignment.BottomRight
        '
        'PicBox
        '
        Me.PicBox.Location = New System.Drawing.Point(86, 103)
        Me.PicBox.Name = "PicBox"
        Me.PicBox.Size = New System.Drawing.Size(100, 50)
        Me.PicBox.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize
        Me.PicBox.TabIndex = 1
        Me.PicBox.TabStop = False
        '
        'frmMain
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.Color.Black
        Me.ClientSize = New System.Drawing.Size(292, 273)
        Me.Controls.Add(Me.PicBox)
        Me.Controls.Add(Me.Label1)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None
        Me.Name = "frmMain"
        Me.WindowState = System.Windows.Forms.FormWindowState.Maximized
        CType(Me.PicBox, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region
    Private Sub frmMain_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        LoadPic()
        LoadSettings()
        Overlay.Opacity = 0
        Overlay.Show(Me)
    End Sub
    Private Sub LoadSettings()
        'Get transition type and time
        Dim settings As RegistryKey
        settings = Registry.LocalMachine.OpenSubKey("Software\CopperScreen", False)
        Transition = settings.GetValue("transition", "fade")
        TransTime = settings.GetValue("transtime", "10")
    End Sub
    Private Sub frmMain_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseMove

        'If the mouse moves any more then 10 points. Close the application
        gTolerance += 1

        If gTolerance > 10 Then
            Me.Close()
            Overlay.Close()
        End If

    End Sub

    Private Sub frmMain_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown
        'If any key is pressed, Close the application
        Me.Close()
        Overlay.Close()
    End Sub
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        gTolerance = 0

        'set delay
        If Time <= TransTime Then
            Time += 1
        Else
            'For safety reasons (to be deleted in the future)
            Time = 0
        End If

        'The transitions
        If Time = (TransTime - 1) Then
            Select Case Transition
                Case "slide"
                    doSlide()
                Case "fade"
                    doFade()
            End Select
        End If

    End Sub
    Private Sub LoadPic()
        'Get dimensions of the user's screen
        Dim y As Integer = Screen.PrimaryScreen.Bounds.Bottom
        Dim x As Integer = Screen.PrimaryScreen.Bounds.Right
        Dim Pic As Bitmap

        'Load new picture
        If PreloadPic Is Nothing Then
            Pic = GetImage.GetImage()
        Else
            Pic = PreloadPic
        End If

        'Adjust pic dimensions
        If Pic.Height > y Or Pic.Width > x Then
            If Pic.Height > Pic.Width Then
                Dim scale As Integer = Pic.Height / y
                Dim Pic2 As New Bitmap(Pic, (Pic.Width / scale), y)
                Pic = Pic2
            Else
                Dim scale As Integer = Pic.Width / x
                Dim Pic2 As New Bitmap(Pic, x, (Pic.Height / scale))
                Pic = Pic2
            End If
        End If

        'Adjust pic postition
        Dim posX As Integer = (x - Pic.Width) / 2
        Dim posY As Integer = (y - Pic.Height) / 2
        PicBox.Left = posX
        PicBox.Top = posY


        'Show pic
        PicBox.Image = Pic

    End Sub
    Private Sub doFade()
        Overlay.Opacity = 0
        For i As Integer = 0 To 10
            Overlay.Opacity += 0.1
        Next
        LoadPic()
        For i As Integer = 0 To 10
            Overlay.Opacity -= 0.1
        Next
        Time = 0
        PreloadPic = GetImage.GetImage()
    End Sub
    Private Sub doSlide()
        Dim x As Integer = (Screen.PrimaryScreen.Bounds.Right - PicBox.Left) / 200
        'Dim x2 As Integer

        For i As Integer = 0 To 220
            PicBox.Left += x
        Next
        Overlay.Opacity = 1
        LoadPic()
        For i As Integer = 0 To 10
            Overlay.Opacity -= 0.1
        Next

        'Pic won't show so this is for later on
        'PicBox.Visible = False
        'LoadPic()
        'x = Screen.PrimaryScreen.Bounds.Right - PicBox.Left
        'x2 = PicBox.Left
        'PicBox.Left = 0 - PicBox.Width
        'PicBox.Visible = True
        'For i As Integer = 0 To 10
        'If Not PicBox.Left >= x2 Then
        'PicBox.Left -= x / 10
        'End If
        'Next
        Time = 0
        PreloadPic = GetImage.GetImage()
    End Sub
End Class
